-- This is a main controller for add-on
GraphicDurabilityPresenter = {}
local Items = {
  ["HELM"] = {Name="hood", Icon = "hood", Slot = EQUIP_SLOT_HEAD, State = nil, Mirror = false, X = 0, Y = -125},
  ["CHEST"] = {Name="chest", Icon = "ches", Slot = EQUIP_SLOT_CHEST, State = nil, Mirror = false, X = -5, Y = -65},
  ["SHOULDERS"] = {Name="shoulder", Icon = "shoud", Slot = EQUIP_SLOT_SHOULDERS, State = nil, Mirror = false, X = -11, Y = -85},
  ["HANDS"] = {Name="glove", Icon = "glovv", Slot = EQUIP_SLOT_HAND, State = nil, Mirror = false, X = 2, Y = -37},
  ["WAIST"] = {Name="waist", Icon = "bel", Slot = EQUIP_SLOT_WAIST, State = nil, Mirror = false, X = -1, Y = 2},
  ["LEGS"] = {Name="legs", Icon = "pants", Slot = EQUIP_SLOT_LEGS, State = nil, Mirror = false, X = -17, Y =  50},
  ["FEET"] = {Name="feet", Icon = "boo", Slot = EQUIP_SLOT_FEET, State = nil, Mirror = false, X = -17, Y =  96},
}

function GraphicDurabilityPresenter:LoadVars()
  GDP.sv = ZO_SavedVars:NewAccountWide(GDP.Config.SvName,2, GDP.Config.Name, GDP.Config.SvDefaults)
end

function GraphicDurabilityPresenter:Init()
  GraphicDurabilityPresenter:LoadVars()
  GraphicDurabilityPresenter:UpdateState()
  GraphicDurabilityPresenter:UpdateTopAnchor()
end

function GraphicDurabilityPresenter:UpdateState()
  for k,v in pairs(Items) do
    v.State = SlotItem:GetState(v.Slot)
    GraphicDurabilityPresenter[k] = v
  end
end

function GraphicDurabilityPresenter:Update()
  GraphicDurabilityPresenter:UpdateState()
  GraphicDurabilityPresenter:Redraw() 
end

function GraphicDurabilityPresenter:UpdateTopAnchor()
  GDPTopControl:ClearAnchors()
  GDPTopControl:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, GDP.sv.OffsetX, GDP.sv.OffsetY)
  GDPTopControl:SetScale(GDP.sv.Scale)
  GDPTopControl:SetDimensions(GDP.sv.DimX, GDP.sv.DimY)
end

function GraphicDurabilityPresenter:Redraw()  
  local scale = GDP.sv.Scale  
  for k, v in pairs(Items) do
    local icon = string.format("/GraphicDurabilityPresenter/Images/%s_%d.dds", v.Icon, v.State);
    local dx = v.X
    local dy = v.Y
    Drawer:Draw(icon, string.format("GDP_%s",v.Name), dx, dy, scale);
  end
end

function GraphicDurabilityPresenter:OnMoveStop()
  GDP.sv.OffsetX = GDPTopControl:GetLeft()
  GDP.sv.OffsetY = GDPTopControl:GetTop()
  GraphicDurabilityPresenter:UpdateTopAnchor()
end

function SetScale(scale)
  if (not scale) then return end
  GDP.sv.Scale = scale
  GDP.sv.OffsetX = 0
  GDP.sv.OffsetY = 0
  GraphicDurabilityPresenter:UpdateTopAnchor()
end

function EnableMove()
  GDP.EnableMove = true
  GDPTopControl:SetMovable(true)
  GDPTopControl:SetMouseEnabled(true)
  GDPTopControl:SetAlpha(1)
end

function DisableMove()
  GDP.EnableMove = false
  GDPTopControl:SetMovable(false)
  GDPTopControl:SetMouseEnabled(false)
end

SLASH_COMMANDS["/gdpscale"] = SetScale
SLASH_COMMANDS["/gdpunlock"] = EnableMove
SLASH_COMMANDS["/gdplock"] = DisableMove