-- This is an object representation of single slot item
SlotItem = {}

-- Represents state of an item.
SlotItem.ItemState = {
  ["OK"] = 1, -- Item has 90 - 100% durability or is not equiped
  ["GOOD"] = 2, -- Item has 60 - 89% durability
  ["MODERATE"] = 3, -- Item has 30 - 59% durability 
  ["DAMAGED"] = 4, -- Item has 1 - 29% durability
  ["DESTROYED"] = 5, -- Item has 0% durability
}

function SlotItem:GetState(slot)

  local hasDurability = DoesItemHaveDurability(0,slot)
  if (not hasDurability) then
    return SlotItem.ItemState["OK"]
  end
  
  local cond = GetItemCondition(0, slot)
  
  if (cond == 0) then
    return SlotItem.ItemState["DESTROYED"]
  end
  
  if (cond > 0 and cond < 30) then
    return SlotItem.ItemState["DAMAGED"]
  end
  
  if (cond >= 30 and cond < 60) then
    return SlotItem.ItemState["MODERATE"]
  end
  
  if (cond >= 60 and cond < 90) then
    return SlotItem.ItemState["GOOD"]
  end
  
  return SlotItem.ItemState["OK"]
end